<script lang="ts">
import { defineProps } from 'vue';
import JIcon from '@new-jira-clone/ui/src/components/icon/JIcon';

export default {
  name: 'JChip',
};
</script>

<script setup lang="ts">
const props = defineProps({
  background: {
    type: String,
    default: '#ddd',
  },
  size: {
    type: String,
    default: 's',
    validator(value: string): boolean {
      return ['custom', 'm', 's', 'xs', 'xxs'].includes(value);
    },
  },
  radius: {
    type: String,
    default: 'xs',
    validator(value: string): boolean {
      return ['custom', 'm', 's', 'xs', 'xxs'].includes(value);
    },
  },
  closable: {
    type: Boolean,
    default: false,
  },
});

defineEmits<{
  (event: 'remove'): void
}>();
</script>

<template>
  <div
    class="j-chip"
    :class="[`size-${props.size}`, `rounded-${props.radius}`]"
  >
    <slot />

    <JIcon
      v-if="closable"
      icon="closeInCircle"
      class="j-icon-close"
      tabindex="0"
      @click="$emit('remove')"
      @keydown.space="$emit('remove')"
      @keydown.enter="$emit('remove')"
    />
  </div>
</template>

<style scoped lang="scss">
.j-chip {
  display: flex;
  align-items: center;
  position: relative;
  background: v-bind(background);
}

.j-icon-close {
  margin-left: 6px;
  width: 18px;
  height: 18px;
  cursor: pointer;

  &:focus-visible {
    outline: var(--j-focus-outline);
  }
}

.size-s {
  padding: 2px 8px;
  max-width: max-content;
  max-height: max-content;
}
</style>
